/* DUMMY extension to register with libiptables during early test phase
 *
 * (C) 2001 by Harald Welte <laforge@gnumonks.org>
 */

#include <libiptables.h>

struct ipt_dummy_data {
	void	*foo;
};

/* acceptable parameters with empty list_heads */
static struct libipt_param dummy_params[] = {
	{ { NULL, NULL, },
	  "param1",
	  "---description of parameter one---",
	  LIBIPT_PARAM_UINT8,
	  LIBIPT_PARAM_FLAG_NONE,
	  { 0 },
	  { ui8: 0 }
	},
	{ { NULL, NULL },
	  "param2",
	  "---description of parameter two---",
	  LIBIPT_PARAM_UINT8,
	  LIBIPT_PARAM_FLAG_NONE,
	  { 0 },
	  { ui8: 0 }
	},
};

static int init()
{

}

static int struct2rule()
{
}

static int check()
{
}

static int rule2struct()
{
}

/* target with uninitialized list_heads */
static libipt_plugin_t dummy = {
	{ NULL, NULL },
	LIBIPT_PLUGIN_TARGET,
	NULL,
	"DUMMY",
	"DUMMY Target",
	LIBIPTABLES_VERSION,
	sizeof(struct ipt_dummy_data),
	sizeof(struct ipt_dummy_data),
	{ NULL, NULL },
	init,
	struct2rule,
	check,
	rule2struct
};

void _init(void)
{
	libipt_prepare_params(&dummy.params, dummy_params, 2);
	libipt_register_plugin(&dummy);
}
