/* iptables2.c, Version $Revision: 698 $
 *
 * The second generation of the iptables userspace program
 *
 * (C) 2001-2003 by Harald Welte <laforge@netfilter.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 
 *  as published by the Free Software Foundation
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *  
 * $Id: libpktt_test.c 698 2004-01-09 00:33:02Z laforge $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libpkttables.h>

#if 0

static struct option original_opts[] = {
	{ "append", 1, 0, 'A' },
        { "insert", 1, 0,  'I' },
        { "replace", 1, 0,  'R' },
        { "list", 2, 0,  'L' },
        { "flush", 2, 0,  'F' },
        { "zero", 2, 0,  'Z' },
        { "new-chain", 1, 0,  'N' },
        { "delete-chain", 2, 0,  'X' },
        { "rename-chain", 2, 0,  'E' },
        { "policy", 1, 0,  'P' },
	{ 0 }
};


static char commands_v_options[NUMBER_OF_CMD][NUMBER_OF_OPT] =
/* Well, it's better than "Re: Linux vs FreeBSD" */
{
	        /*     -n  -s  -d  -p  -j  -v  -x  -i  -o  -f  --line */
	/*INSERT*/    {'x',' ',' ',' ',' ',' ','x',' ',' ',' ','x'},
	/*DELETE*/    {'x',' ',' ',' ',' ',' ','x',' ',' ',' ','x'},
	/*DELETE_NUM*/{'x','x','x','x','x',' ','x','x','x','x','x'},
	/*REPLACE*/   {'x',' ',' ',' ',' ',' ','x',' ',' ',' ','x'},
	/*APPEND*/    {'x',' ',' ',' ',' ',' ','x',' ',' ',' ','x'},
	/*LIST*/      {' ','x','x','x','x',' ',' ','x','x','x',' '},
	/*FLUSH*/     {'x','x','x','x','x',' ','x','x','x','x','x'},
	/*ZERO*/      {'x','x','x','x','x',' ','x','x','x','x','x'},
	/*NEW_CHAIN*/ {'x','x','x','x','x',' ','x','x','x','x','x'},
	/*DEL_CHAIN*/ {'x','x','x','x','x',' ','x','x','x','x','x'},
	/*SET_POLICY*/{'x','x','x','x','x',' ','x','x','x','x','x'},
	/*CHECK*/     {'x','+','+','+','x',' ','x',' ',' ',' ','x'},
	/*RENAME*/    {'x','x','x','x','x',' ','x','x','x','x','x'}
};

#endif

const char *program_version;
const char *program_name;

#define OUTBUFSIZE	1024

int foobar(libpktt_handle_t *h)
{
	libpktt_plugin_t *pl;
	char *outstr;

	for (pl = libpktt_first_plugin(h);
	     pl = libpktt_next_plugin(h, pl); pl != NULL) {
		outstr = (char *) malloc(OUTBUFSIZE);
		libpktt_print_pluginhelp(outstr, OUTBUFSIZE-1, pl);
		printf("%s\n", outstr);
	}

	return 0;
}

int create_ttl_rule(libpktt_handle_t *h)
{
	libpktt_rule_t *ruleh;
	libpktt_relem_t *relemh;
	libpktt_plugin_t *pl;

	pl = libpktt_get_pluginfo("ttl");
	if (!pl) {
		fprintf(stderr, "can't get pluginfo for ttl\n");
		return -1;
	}

	ruleh = libpktt_gethandle_rule(h, 0);
	if (!ruleh) {
		fprintf(stderr, "can't get new rulehandle\n");
		return -2;
	}


	relemh = libpktt_gethandle_relem(ruleh, pl);
	if (!relemh) {
		fprintf(stderr, "can't get new relemhandle\n");
		return -3;
	}

	v = get_value_by_paramname(pl, "ttl-eq");
	if (!v) {
		fprintf(stderr, "can't get value for ttl-eq\n");
		return -4;
	}
	libpktt_param_set_value(v);
	v->value.ui8 = 12;



}

int main(int argc, char *argv[]) 
{
	int ret;
	char *table = "filter";
	libpktt_handle_t *h;

	program_name = "iptables";
//	program_version = IPTABLES_VERSION;
	program_version = "2.0.0";

	if (libpktt_init() != TRUE) {
		fprintf(stderr, "error during libpktt_init()\n");
		exit(1);
	}

	h = libpktt_get_handle();	

	foobar(h);

	create_ttl_rule();


	libpktt_free_handle(h);

	libpktt_exit();
	
}
